--- init sprite table


img=love.graphics.newImage("art.png")
quads= {}
quadmatcher = {}
local ii=1
for yy=0,4 do
	for xx=0,4 do
		quads[ii]=love.graphics.newQuad( xx*128, yy*128, 128, 128, 640, 640)
		ii = ii + 1
	end
end


quadmatcher["iron"] = 1
quadmatcher["copper"] =2
quadmatcher["obsid"] =3
quadmatcher["meteor"] =4
quadmatcher["trash"] =5

quadmatcher["gold"] =6
quadmatcher["silver"] =8
quadmatcher["W_gold"] =7
quadmatcher["F_gold"] =9

quadmatcher["R_iron"] =11
quadmatcher["R_copper"] =12
quadmatcher["bronze"] =13
quadmatcher["tin"] =14
quadmatcher["mixed"] =15
quadmatcher["steel"] =16
quadmatcher["etherial"] =17

quadmatcher["damas"] =21
quadmatcher["myth"] =22
quadmatcher["D_steel"] =23
quadmatcher["P_iron"] =24
quadmatcher["P_copper"] =25


function get_ore_quad(name)
	return quads[quadmatcher[name]]
end

function draw_ore(x,y,name)
	love.graphics.draw(img,get_ore_quad(name), x, y)
end

carts={}
carts_img=love.graphics.newImage("carts.png")

carts[1]=love.graphics.newQuad(0*128,0*128,128,128,1024,768)
carts[2]=love.graphics.newQuad(1*128,0*128,128,128,1024,768)
carts[3]=love.graphics.newQuad(0*128,1*128,128,128,1024,768)
carts[4]=love.graphics.newQuad(1*128,1*128,128,128,1024,768)
carts[5]=love.graphics.newQuad(2*128,1*128,128,128,1024,768)
carts[6]=love.graphics.newQuad(3*128,1*128,128,128,1024,768)

function draw_cart(x,y,id)
	love.graphics.draw(carts_img,carts[id],x,y)
end