require "tamale"

--tamale.matcher

print("loaded")

function output(n)
	f=tamale.matcher{
	{  {"trash"},{"trash"}},
	{  {"obsid"},{"heavy"}},
	{  {"P_iron"},{"heavy"}},
	{  {"P_copper"},{"heavy"}},
	{  {"R_iron"},{"bar"}},
	{  {"R_copper"},{"bar"}},
	{  {"bronze"},{"bar"}},
	{  {"tin"},{"bar"}},
	{  {"mixed"},{"bar"}},
	{  {"gold"},{"fancy"}},
	{  {"silver"},{"fancy"}},
	{  {"F_gold"},{"fancy"}},
	{  {"steel"},{"fancy"}},
	{  {"damas"},{"fancy"}},
	{  {"meteor"},{"fancy"}},
	{  {"myth"},{"end"}},
	{  {"W_gold"},{"end"}},
	{  {"etherial"},{"end"}},
	{  {"D_steel"},{"end"}},
	{  {"error"},{"error"}},
	}
	local o = f({n})[1]
	--print("output",n,o)
	return {n,o}
end

function trash_matcher(x) return output("obsid") end

clean_tables= {}

--------

local V = tamale.var

local a,b,c,d,e =  V("a"), V("b"),V("c"),V("d"),V("e")
local w = V("_")

local function raw_igc(t) return t.a > t.b end
local function raw_iec(t) return t.a == t.b end
local function raw_ilc(t) return t.a < t.b end
local function raw_ab7(t) return t.a + t.b > 6 end
local function raw_ab5(t) return t.a + t.b > 4 end
local function raw_an0(t) return t.a > 0 end

clean_tables["raw"]= {iron=0,copper=0}

raw_matcher = tamale.matcher{
	{ {iron=3,copper=0}   ,output("R_iron")                        , partial=true},
	{ {iron=a,copper=0}   ,output("P_iron")                        , partial=true},
	{ {iron=0,copper=3}   ,output("R_copper")                      , partial=true},
	{ {iron=0,copper=a}   ,output("P_copper")                      , partial=true},
	{ {iron=a,copper=b}   ,output("obsid")        ,when=raw_ab7    , partial=true},
	{ {iron=a,copper=b}   ,output("trash")        ,when=raw_ab5    , partial=true},
	{ {iron=a,copper=b}   ,output("tin")          ,when=raw_igc    , partial=true},
	{ {iron=a,copper=b}   ,output("bronze")       ,when=raw_ilc    , partial=true},
	{ {iron=a,copper=b}   ,output("mixed")        ,when=raw_iec    , partial=true},
	{ {iron=a,copper=b}   ,output("error")                         , partial=true},
}
--[[
function printz(t,a,b,c)
	print(a .. b .. c .. "  ,  " .. t[1] .. "  , " .. t[2])
end


--printz({"I","working"},1,2,3)

--print(raw_matcher({iron=1,copper=1,trash=0}))
--print(output("silver")[2])

for k=0,1 do
	for j=0,5 do
		for i=0,5 do
			if(i+j+k >2) then
				local t = raw_matcher({iron=i,copper=j,trash=k})
				--t = output("error")
				printz(t,i,j,k)
			end
		end
	end
end

--]]

local function heavy_ab2(t) return t.a + t.b < 4 end
local function heavy_abL(t) return t.a + t.b > 3 end
local function heavy_a_2(t) return t.a > 1 end

clean_tables["heavy"]={P_iron=0,P_copper=0,obsid=0}

heavy_matcher= tamale.matcher{
	{  {P_iron=0,P_copper=0,obsid=w}  ,output("meteor")                   , partial=true},
	{  {P_iron=w,P_copper=0,obsid=0}  ,output("silver")                   , partial=true},
	{  {P_iron=0,P_copper=3,obsid=0}  ,output("F_gold")                   , partial=true},
	{  {P_iron=0,P_copper=w,obsid=0}  ,output("gold")                     , partial=true},
	{  {P_iron=w,P_copper=w,obsid=0}  ,output("damas")                    , partial=true},
	{  {P_iron=a,P_copper=b,obsid=w}  ,output("meteor")  ,when=heavy_ab2  , partial=true},
	{  {P_iron=a,P_copper=b,obsid=1}  ,output("damas")   ,when=heavy_abL  , partial=true},
	{  {P_iron=w,P_copper=w,obsid=a}  ,output("meteor")  ,when=heavy_a_2  , partial=true},
	{  {P_iron=w,P_copper=w,obsid=w}  ,output("error")                    , partial=true},
}


--[[
function printz(t,a,b,c)
	print(a .. b .. c .. "  ,  " .. t[1] .. "  , " .. t[2])
end

for k=0,5 do
	for j=0,5 do
		for i=0,5 do
			if(i+j+k >2 and i+j+k <10) then
				local t = heavy_matcher({P_iron=i,P_copper=j,obsid=k} )
				--t = output("error")
				printz(t,i,j,k)
			end
		end
	end
end
]]--
--[[
function bar_al0(t) return t.a<1 end
function bar_al3(t) return t.a<-2 end
function bar_ag0(t) return t.a>0 end
function bar_ag1(t) return t.a>1 end
function bar_ag2(t) return t.a>2 end
function bar_ag4(t) return t.a>4 end
function bar_big(t) return t.a+t.b+t.c+t.d > 4 end


clean_tables["bar"]={R_iron=0,R_copper=0,mixed=0,bronze=0,tin=0}

--todo fix this shit
function bar_matcher(t)
	local t1 = bar_table_fix(t)
	--print("hi")
	return bar1_matcher(t1)
end
bar1_matcher= tamale.matcher{--debug=true,
{ {R_iron=w,R_copper=w,mixed=w,shit=w,ironness=a},output("steel")     ,when=bar_ag4,partial=true},
{ {R_iron=0,R_copper=0,mixed=0,shit=w,ironness=w},output("trash")                  ,partial=true},
{ {R_iron=w,R_copper=0,mixed=0,shit=0,ironness=w},output("steel")                  ,partial=true},
{ {R_iron=a,R_copper=w,mixed=w,shit=0,ironness=w},output("steel")     ,when=bar_ag1,partial=true},
{ {R_iron=w,R_copper=w,mixed=w,shit=0,ironness=a},output("F_gold")    ,when=bar_al3,partial=true},
{ {R_iron=0,R_copper=w,mixed=0,shit=0,ironness=0},output("F_gold")                 ,partial=true},
{ {R_iron=w,R_copper=0,mixed=a,shit=0,ironness=w},output("damas")     ,when=bar_ag1,partial=true},
{ {R_iron=a,R_copper=b,mixed=c,shit=d,ironness=w},output("meteor")    ,when=bar_big,partial=true},
{ {R_iron=w,R_copper=1,mixed=a,shit=0,ironness=w},output("damas")     ,when=bar_ag1,partial=true},
{ {R_iron=w,R_copper=0,mixed=a,shit=1,ironness=w},output("damas")     ,when=bar_ag1,partial=true},
{ {R_iron=w,R_copper=w,mixed=w,shit=w,ironness=a},output("trash")     ,when=bar_al0,partial=true},
{ {R_iron=w,R_copper=w,mixed=w,shit=0,ironness=a},output("steel")     ,when=bar_ag0,partial=true},
{ {R_iron=w,R_copper=w,mixed=w,shit=1,ironness=a},output("steel")     ,when=bar_ag0,partial=true},
{ {R_iron=w,R_copper=w,mixed=w,shit=2,ironness=a},output("steel")     ,when=bar_ag1,partial=true},
{ {R_iron=a,R_copper=w,mixed=w,shit=0,ironness=w},output("steel")     ,when=bar_ag0,partial=true},
{ {R_iron=w,R_copper=w,mixed=w,shit=a,ironness=w},output("trash")     ,when=bar_ag0,partial=true},
{ {R_iron=w,R_copper=w,mixed=w,shit=w,ironness=w},output("error")                  ,partial=true},

}

function bar_table_fix(t)
	o_shit=t.tin+t.bronze
	o_ironness= (-t.bronze)+t.tin+ (t.R_iron*3) - (t.R_copper*3)+t.mixed
	--print(t.R_iron,t.R_copper,t.mixed,o_shit,o_ironness)
	return {R_iron=t.R_iron,
			R_copper=t.R_copper,
			mixed= t.mixed,
			shit=o_shit,
			ironness=o_ironness}
end
]]--


function bar_ag3(t) return t.a > 2 end
function bar_ag2(t) return t.a > 1 end
function bar_ag1(t) return t.a > 0 end
function bar_big(t) return (t.a+t.b+t.c+t.d+t.e) > 4 end



bar_matcher = tamale.matcher{
	{  {R_iron=w,R_copper=a,mixed=w,bronze=w,tin=w},output("F_gold")      ,when=bar_ag3,partial=true},
	{  {R_iron=w,R_copper=w,mixed=a,bronze=w,tin=w},output("damas")       ,when=bar_ag2,partial=true},
	{  {R_iron=a,R_copper=w,mixed=w,bronze=w,tin=w},output("steel")       ,when=bar_ag3,partial=true},
	{  {R_iron=a,R_copper=b,mixed=c,bronze=d,tin=e},output("obsid")       ,when=bar_big,partial=true},
	{  {R_iron=a,R_copper=w,mixed=w,bronze=w,tin=w},output("steel")       ,when=bar_ag2,partial=true},
	{  {R_iron=w,R_copper=w,mixed=w,bronze=0,tin=0},output("damas")                    ,partial=true},
	{  {R_iron=0,R_copper=w,mixed=w,bronze=w,tin=0},output("F_gold")                   ,partial=true},
	{  {R_iron=a,R_copper=0,mixed=w,bronze=0,tin=w},output("steel")       ,when=bar_ag1,partial=true},
	{  {R_iron=w,R_copper=w,mixed=0,bronze=w,tin=w},output("trash")                    ,partial=true},
	{  {R_iron=w,R_copper=w,mixed=w,bronze=w,tin=w},output("obsid")                    ,partial=true},
}


function s(n,str)
	if n == 0 then return ""
	elseif n== 1 then return str
	else return n .. "x " .. str end 
end

function printz(t,a,b,c,d,e)
	sss= "     "..s(a,"iron, ") .. s(b,"copper, ") .. s(c,"mixed, ") .. s(d,"tin, ") .. s(e,"bronze")
	print(a .. b .. c .. d .. e .. "  ,  " .. t[1] .. "  , " .. t[2].. sss)
end
--[[
for n=0,5 do
for l=0,5 do
for k=0,5 do
	for j=0,5 do
		for i=0,5 do
			if(i+j+k+l+n >2 and i+j+k+l+n <6) then
				local t = bar_matcher({R_iron=i,R_copper=j,mixed=k,tin=l,bronze=n})
				--t = output("error")
				--if t[1]== "error" then
				printz(t,i,j,k,l,n)
			--end
			end
		end
	end
end
end
end
]]

function fan_ag3(t) return t.a>3 end
function fan_ag1(t) return t.a>1 end
function fan_al2(t) return t.a<2 end

clean_tables["fancy"]={gold=0,silver=0,F_gold=0,steel=0,damas=0,meteor=0}


fancy_matcher= tamale.matcher{
  {  {gold=a,silver=1,F_gold=0,steel=0,damas=0,meteor=0}, output("W_gold")    ,when=fan_ag3,partial=true},
  {  {gold=2,silver=2,F_gold=1,steel=0,damas=0,meteor=0}, output("W_gold")                 ,partial=true},
  {  {gold=0,silver=0,F_gold=0,steel=w,damas=0,meteor=0}, output("myth")                   ,partial=true},
  {  {gold=0,silver=0,F_gold=0,steel=w,damas=w,meteor=w}, output("D_steel")                ,partial=true},
  {  {gold=w,silver=w,F_gold=w,steel=a,damas=w,meteor=w}, output("myth")      ,when=fan_ag1,partial=true},
  {  {gold=w,silver=w,F_gold=a,steel=0,damas=0,meteor=0}, output("etherial")  ,when=fan_al2,partial=true},
  {  {gold=w,silver=w,F_gold=w,steel=w,damas=w,meteor=w}, output("meteor")                 ,partial=true},
}